import java.util.*;
import greenfoot.*;

/**
 * Elternklasse von Peetie. Wird für diverse Variablen + Methoden benutzt, die Peetie erbt, damit die Klasse Peetie schlank bleibt und von den Schüler/innen einfach bedient werden kann.
 * TYP 1 (statisches Szenario)
 */
public abstract class AI_Robot extends Actor
{
    protected SzenarioTyp aktuellesSzenario;
    protected String aktuellesSzenarioString;
    protected String szenarioArt;

    protected String peetieDefaultImage;
    protected int peetieStartposX;
    protected int peetieStartposY;
    protected int peetieDirection;
    protected int delay; // Wie lange wartet Peetie zwischen einzelnen Aktionen (gehe Links, geheRechts...)
    protected int ptSpeed; // Wie schnell bewegt sich Peetie
    // protected int quarzX, quarzY;

    // Ballerei
    protected int rocketDelay = 100; // Wie lange dauert es zwischen zwei Raketenabschuessen?
    protected int numberFighterdrones; // Ep05M03   
    protected int rocketDelayCounter;
    protected boolean objectShotDown = false;
    protected boolean ptWasHit = false;
    protected boolean isSpacePressed = false;

    // Smartphone
    protected Label lblTextausgabe;

    /*
     *    ################################################################
     *    ######## SZENARIO-UEBERGREIFEND: KONSTRUKTOR, ACT ###############
     *    ################################################################
    /*
    /*
     *    #### KONSTRUKTOR (kann in unterschiedlichen Szenarien unterschiedlich sein)
     *    initialisiert alle szenariospezifischen Werte, auch wenn sie nicht gebraucht werden
     */
    public AI_Robot() {
        // Werte aus dem SzenarioKonfigurator übernehmen
        this.szenarioArt = SzenarioKonfigurator.szenarioArt;

        this.peetieDefaultImage = SzenarioKonfigurator.peetieDefaultImage;
        this.peetieStartposX = SzenarioKonfigurator.peetieStartposX;
        this.peetieStartposY = SzenarioKonfigurator.peetieStartposY;
        this.peetieDirection = SzenarioKonfigurator.peetieDirection;
        this.delay = SzenarioKonfigurator.delay;
        this.ptSpeed = SzenarioKonfigurator.ptSpeed;
        // this.quarzX = SzenarioKonfigurator.quarzX;
        // this.quarzY = SzenarioKonfigurator.quarzY;
        this.anzahlZirkonplatten = SzenarioKonfigurator.anzahlZirkonplatten;

        // Eventuell zusätzliche Initialisierung
        setImage(this.peetieDefaultImage);
        this.setRotation(this.peetieDirection);
        // System.out.println("Peetie Start Position: X = " + peetieStartposX + ", Y = " + peetieStartposY);

    }

    /*
     *    #### act-Methode - unterscheidet sich in den Szenarien
     */
    public void act() {
        // System.out.println("akt. szen: " + this.aktuellesSzenario);
        if(this.szenarioArt.equals("2-dynamisch")) {
            // System.out.println("szenario ist dynamisch");
            this._run();
            this.checkIfPeetieWasHit(); // nur relevant für drohnenbomben oder schrottteile
            this.ptCheckCollisionWithDrone();
            this.rocketDelayCounter--;
        } else if(this.szenarioArt.equals("1-statisch")) {

            this._runOrganize();
            Greenfoot.stop();

        } else if(this.szenarioArt.equals("3-smartphone")) {
            this._runOrganize();
            Greenfoot.stop();

        } else if(this.szenarioArt.equals("4-liftoff")) {
            this._run();
        }

        // Wenn die act-Methode als Loop laufen soll, muss 
        // this._run();
        // entkommentiert sein

    }

    /*
     *    ################################################################
     *    ######## AB HIER ALLES GLEICH FUER ALLE SZENARIEN ##############
     *    ################################################################
    /*   

    /* SETUP-/INITIALIZE-functions */
    public void addedToWorld(World w) {
        this.setLocation(this.peetieStartposX, this.peetieStartposY);
        this.setImage(this.peetieDefaultImage);
        this.mars = (Mars)w;
        this.gridSize = this.mars.getGridSize();
        this.aktuellesSzenario = this.mars.getAktuellesSzenario();
        this.aktuellesSzenarioString = this.aktuellesSzenario.toString();
        this.warten(2);

    }

    public void _runOrganize() {
        this.warten(20);
        // Blendet Buttons vor Beginn von run() aus und danach wieder ein
        this.mars.buttonsVerstecken();
        this.warten(1);
        this._run();
        this.warten(80);
        this.mars.buttonsZeigen();
        Greenfoot.stop();
    }
    /*
     *    ################################################################
     *    ######## SZENARIOSPEZIFISCHE VARIABLEN #########################
     *    ################################################################
     *    (werden alle im Konstruktor initialisiert, können deshalb in allen Szenarien gleich deklariert werden)
    /*

    /*
     *    #### Variablen, deren Initialwerte in allen Szenarien gleich sind
     */  

    protected int raketenVerzoegerungscounter;

    // ##### Weitere szenarioübergreifende Variablen, nicht ändern
    protected Mars mars; // Wird in der addedToWorld-Methode initialisiert 

    protected int gridSize; // Wird in der addedToWorld-Methode initialisiert
    protected int dx, dy; // Für Sensoren (istFelsVoraus etc.) - In welche Richtung/wie weit entfernt liegt das nächste Kollisions Objekt?

    protected boolean buttonsSindEingeblendet = true;
    protected boolean missionAccomplished = false;
    protected boolean arrivedAtBase = false; // um die while-Schleife kontrolliert beenden zu koennen
    protected boolean arrivedAtHolomarker = false;

    protected int anzahlZirkonplatten;
    /** 
     * #########################################################
     * #########################################################
     * ################# PEETIE-BEFEHLE ########################
     * #########################################################
     * #########################################################
     * werden von Schueler/innen verwendet (geheRechts usw.)
     */

    /**
     * #################### BEWEGEN ######################
     * Richtung, Bild, Bildrotation, Sound
     */
    /** Peetie bewegt sich ein Feld nach Osten.*/
    public void geheRechts() { this.bewegen(0, "peetie_rechts_50.png", 0, "STEP1"); }

    /** Peetie bewegt sich ein Feld nach Westen.*/
    public void geheLinks() { this.bewegen(180, "peetie_links_50.png", 180, "STEP2"); }

    /** Peetie bewegt sich ein Feld nach Norden.*/
    public void geheHoch() { this.bewegen(270, "peetie_hoch_50.png", 90, "STEP3"); }

    /** Peetie bewegt sich ein Feld nach Süden.*/
    public void geheRunter() { this.bewegen(90, "peetie_runter_50.png", 270, "STEP4"); }

    /** Peetie dreht sich um 90 Grad **/
    public void drehen() {
        this.turn(90);
        this.warten(15);
    }

    /** Peetie macht eine Pause. **/
    public void pausieren() {
        this.warten(50);
    }

    /** Peetie gräbt ein Loch an seiner aktuellen Position.*/
    public void lochGraben() {
        Item i = new Item();
        i.setImage("peetie_runter_50_loch.png");
        Sound.play("GRABEN");
        this.getWorld().addObject(i, this.getX(), this.getY());
    }

    /**
     * #################### FELSEN, KRATER UMRUNDEN ######################
     */
    /** Wenn auf dem Feld vor Peetie (also in Peeties Blickrichtung) ein Fels ist, wird true zurückgegeben. */
    public boolean istFelsVoraus() {
        return this.istObjektVoraus(Fels.class);
    }

    /** Wenn auf dem Feld über Peetie (also nördlich von Peetie) ein Fels ist, wird true zurückgegeben. */
    public boolean istFelsOben() {
        return (this.getOneObjectAtOffset(0, -30, Fels.class) != null);
    }

    /** Wenn auf dem Feld vor Peetie ein Krater ist, wird true zurückgegeben. */
    public boolean istKraterVoraus() {
        return this.istObjektVoraus(Krater.class);
    }

    /** Peetie geht runter-rechts-rechts-hoch oder runter-links-links-hoch, je nach Richtung, in die er blickt. */
    public void aussenrumgehen() {
        // funktioniert nur, keine 2 Felsen nebeneinander liegen
        switch(this.getRotation()) {
            case 0: // Peetie geht nach Osten
                this.geheRunter();
                this.geheRechts();
                this.geheRechts();
                this.geheHoch();
                this.setRotation(0);
                break;
            case 180: // Peetie geht nach Westen
                this.geheRunter();
                this.geheLinks();
                this.geheLinks();
                this.geheHoch();
                this.setRotation(180);
                break; 
        }

    }
    /**
     * #################### QUARZMUNITION HERSTELLEN ######################
     */
    /** Peetie stellt eine Quarzpatrone her. */
    /*  public void stelleQuarzmunitionHer() {
    Quarzmunition q = new Quarzmunition();
    this.getWorld().addObject(q, this.quarzX, this.quarzY);
    Sound.play("PLOCK");

    if(this.quarzX > this.getWorld().getWidth() - 200) {
    this.quarzX = 150;
    this.quarzY += 50;
    }
    this.quarzX += 65;
    this.warten();
    } *

    /**
     * #################### QUARZMUNITION ABFEUERN ######################
     */
    /** 
     * Peetie feuert einen Schuss Quarzmunition auf die feindliche Basis.
     *
     */
    /*   public void quarzmunitionAbfeuern() {
    this.warten(2);
    Quarzmunition r = new Quarzmunition();
    this.getWorld().addObject(r, this.getX(), this.getY() - 20);
    r.getImage().scale(r.getImage().getWidth()/2, r.getImage().getHeight()/2);
    Sound.play("ABSCHUSS");
    r.fliegen();
    this.getWorld().removeObject(r);
    this.warten(10);
    } */
    /**
     * #################### RAKETEN SAMMELN ######################
     */
    /** Wenn Peetie auf einer Rakete steht, wird true zurückgegeben. */
    public boolean raketeWirdBeruehrt() {
        return this.isTouching(Rakete.class);
    }

    /** Peetie nimmt die Rakete auf seinem Feld. */
    public void raketeAufnehmen() {
        if(this.raketeWirdBeruehrt()) {
            Rakete r = (Rakete)this.getOneIntersectingObject(Rakete.class);
            if(!r.getRaketeIstSicher()) {
                this.missionEnde("Aufgenommene Rakete war ein Sprengkörper von Syberdrone - #FAIL", "EXPLOSION");
            } else {
                this.removeTouching(Rakete.class);
                Sound.play("RAKETENEHMEN");
                if(this.alleRaketenGesammelt()) {
                    /*
                     * Hier zusätzliche Bedingungen möglich, bspw. wenn Peetie das Trümmerfeld
                     * überwunden haben muss:
                     * if(this.getY() > 500) …
                     */
                    if(true) {
                        this.missionEnde("Alle Raketen gesammelt, perfekt!", "YEAH!");
                    }
                }
            }
        } else {
            this.missionEnde("Keine Rakete zum Aufnehmen. Peetie stürzt in einer Endlosschleife ab.", "ENDLOSSCHLEIFE");
        }
    }

    /** Prüft, ob die Rakete ein getarnter Sprengkörper von Syberdrone ist. */
    public boolean raketeIstSicher() {
        Rakete r = (Rakete)this.getOneIntersectingObject(Rakete.class);
        if(r != null) {
            if(r.getRaketeIstSicher()) {
                return true;
            } else {
                return false;
            }
        } else {
            this.missionEnde("Keine Rakete. Peetie kontrolliert wieder und wieder und stürzt ab.", "ENDLOSSCHLEIFE"); 
        }
        return false;
    }

    /** Peetie entschärft die gefakte Syberdrone-Rakete auf seinem Feld. */
    public void entschaerfen() {
        Rakete r = (Rakete)this.getOneIntersectingObject(Rakete.class);
        if(r != null) {
            if(r.getRaketeIstSicher()) { // es wird fälschlicherweise entschärft
                this.missionEnde("Beim Versuch, eine echte Rakete zu entschärfen, fliegt Peetie in die Luft. #FAIL", "EXPLOSION"); 
            } else {
                r.setRaketeIstSicher(true);
                Sound.play("ENTSCHAERFEN");
                r.getImage().setTransparency(80);
                r.getImage().scale(r.getImage().getWidth() * 2, r.getImage().getHeight() * 2);
                this.mars.showText("Rakete erfolgreich entschärft!!", this.getWorld().getWidth()/2, this.getWorld().getHeight()/2);
                this.warten(50);
                this.getWorld().showText("", this.getWorld().getWidth()/2, this.getWorld().getHeight()/2);
            }
        } else {
            this.missionEnde("Keine Rakete. Peetie entschärft sich aus Versehen selbst. #FAIL", "EXPLOSION");
        }
    }

    /** 
     * Wenn Peetie die Basis erreicht hat, wird true zurückgegeben.
     */
    /*  public boolean basisErreicht() {
    return this.arrivedAtBase;
    } */

    /** 
     * Wenn Peetie einen Holomarker erreicht hat, wird true zurückgegeben.
     */
    public boolean holomarkerErreicht() {
        return this.arrivedAtHolomarker;
    }

    /**
     * #################### LAUNCH ######################
     */
    /** Wenn Peetie alles erledigt hat, kann er mit diesem Befehl vom Mars starten! */
    public void initiateStartSequence() {
        if(this.aktuellesSzenarioString.equals("e7m7")) { // Befehl nur im entsprechenden Szenario möglich
            Greenfoot.setSpeed(50);
            Uhr.starten();
            this.wartenSekunden(2.2);

            while(this.getX() < 480) { // fährt zur plattform
                this.setImage("peetie_rechts_50.png");
                this.setLocation(this.getX() + 1, this.getY());

                // Peetie wartet auf dem Weg zur Plattform
                if(this.getX() == 250) { 
                    this.setImage("peetie_hoch_50.png");
                    this.wartenSekunden(3.3);
                    this.setImage("peetie_rechts_50.png");
                    this.setLocation(this.getX() + 1, this.getY());
                }

                this.wartenMillisekunden(43); // Wartezeit zwischen einzelnen Bewegungen

            }
            /* ------- 32s ------ */
            this.setImage("peetie_runter_50.png");
            this.wartenSekunden(13); // steht auf plattform, countdown
            this.setImage("peetie-burning-64px.png");
            this.wartenSekunden(3);

            for(int i = 1; i <= 30; i++) { // start 1
                this.setLocation(this.getX() + (Greenfoot.getRandomNumber(1) - Greenfoot.getRandomNumber(2)), this.getY() - i);
                if(i == 20) {
                    this.setImage("peetie_runter_50.png");
                }
                this.wartenMillisekunden(35);
            }
            this.setImage("peetie-burning-64px.png");
            this.wartenSekunden(0.7);
            for(int i=1; i <= 25; i++) {
                this.turn(Greenfoot.getRandomNumber(2) - Greenfoot.getRandomNumber(3));
                this.setLocation(this.getX() + Greenfoot.getRandomNumber(4) - Greenfoot.getRandomNumber(4), this.getY());
                if((Greenfoot.getRandomNumber(2) + 1) % 2 == 0) {
                    this.setImage("peetie-burning-64px.png");
                } else {
                    this.setImage("peetie_runter_50.png");
                }
                this.wartenMillisekunden(20);
            }
            this.setRotation(0);
            for(int i = 1; i <= 30; i++) { // absturz
                this.setLocation(this.getX() + (Greenfoot.getRandomNumber(5) - Greenfoot.getRandomNumber(10)), this.getY() + i);
                if(i == 20) {
                    this.setImage("peetie_runter_50_verformt.png");
                }
                this.wartenMillisekunden(80);
            }
            this.setImage("peetie_runter_50_verformt.png");
            this.wartenMillisekunden(600);
            this.setImage("peetie_runter_50.png");
            this.wartenMillisekunden(600);
            this.setImage("peetie-feuerausstoss.png");
            this.setLocation(this.getX(), this.getY() + 13); 
            //      this.setLocation(this.mars.getWidth()/2, this.mars.getHeight() - 50);
            this.wartenSekunden(4);

            int startY = 536; // Startposition auf der Y-Achse
            int worldHeight = 640; // Gesamthöhe der Welt
            GreenfootImage g = this.getImage();
            int initialWidth = g.getWidth();
            int initialHeight = g.getHeight();

            // Variable, die die kumulative Rechtsbewegung speichert
            double cumulativeRightMovement = 0;

            for(int i = 1; i <= 400; i++) { // Lange Schleife für eine langsame Animation
                // Langsamerer Start und frühere, stärkere Verlangsamung der Bewegung nach oben
                double moveAmount;
                if (i <= 200) {
                    moveAmount = 10 / Math.log(i + 10); // Langsamer Start und moderate Verlangsamung
                } else {
                    moveAmount = 5 / Math.log(i - 190); // Stärkere Verlangsamung in der zweiten Hälfte
                }

                int newY = this.getY() - (int)moveAmount;
                if (newY <= 50) { // Peetie darf sich 50 Pixel über der Oberkante nicht weiter nach oben bewegen
                    break; // Beendet die Bewegung, wenn Peetie sich nahe der oberen Grenze befindet
                }

                // Weiter abgeschwächte Berechnung der neuen x-Position für die Rechtsbewegung

                cumulativeRightMovement += Math.log(i + 1) / 195.3125; // Dezente und langsame Zunahme der Rechtsbewegung
                int newX = this.getX() + (int)cumulativeRightMovement;

                this.setLocation(newX, newY); // Bewegung nach oben und nach rechts

                // Verkleinerung ab y = 300
                if (newY <= 300) {
                    double scaleFactor = Math.max(0.01, 1.0 - (i - 100) / 300.0); // Kontinuierliche Verkleinerung bis zu einem winzigen Punkt
                    int newWidth = (int)(initialWidth * scaleFactor);
                    int newHeight = (int)(initialHeight * scaleFactor);

                    if (newWidth > 0 && newHeight > 0) {
                        g.scale(newWidth, newHeight); // Proportional skalieren
                    }
                }

                // Transparenz erhöhen entsprechend der Entfernung (beschleunigt)
                int transparency = (int)Math.max(100, 255 - (Math.pow((i / 400.0), 2) * 155)); // Transparenz von 255 auf 100
                g.setTransparency(transparency);

                Greenfoot.delay(3); // Verkürzte Pause für eine flüssigere Animation
            }

            Greenfoot.stop();
        }
    }

    // Methode zum Warten für die angegebene Anzahl von Millisekunden
    // ChatGPT 12.12.2024
    public void wartenMillisekunden(long millisekunden) 
    {
        Uhr.starten(); // Starte die Uhr
        while (Uhr.vergangeneMillisekunden() < millisekunden) {
            // Hier kannst du andere Aktionen durchführen, während du wartest
            // Zum Beispiel: andere Objekte aktualisieren oder Animationen abspielen
            Greenfoot.delay(1); // Kurze Verzögerung, um die Schleife nicht zu schnell auszuführen
        }
        Uhr.stoppen(); // Stoppe die Uhr, wenn die Wartezeit vorbei ist
    }

    public void wartenSekunden(double sekunden) 
    {
        long millisekunden = (long)(sekunden * 1000); // Umrechnung in Millisekunden
        Uhr.starten(); // Starte die Uhr
        while (Uhr.vergangeneMillisekunden() < millisekunden) {
            // Hier kannst du andere Aktionen durchführen, während du wartest
            Greenfoot.delay(1); // Kurze Verzögerung, um die Schleife nicht zu schnell auszuführen
        }
        Uhr.stoppen(); // Stoppe die Uhr, wenn die Wartezeit vorbei ist
    }

    /**
     * #################### ZIRKONPLATTEN ######################
     */
    /** Peetie nimmt die Zirkonplatte, die sich auf seinem Feld befindet. */
    public void zirkonplatteAufnehmen() {
        if(this.zirkonplatteWirdBeruehrt()) {
            if(this.anzahlZirkonplatten > 0) {
                Sound.play("BING");
                textAusgeben("Peetie trägt bereits eine Zirkonplatte.");
                this.warten(30);
                textAusgeben("");
                // if(this.zirkonplatteIstInstabil()) {
                // Zirkonplatte z = (Zirkonplatte)getOneIntersectingObject(Zirkonplatte.class);

                // Sound.play("GROWL");
                // for(int i = 1; i <= 100; i++) {
                // z.getImage().scale(z.getImage().getWidth() + 2, z.getImage().getHeight()+2);
                // z.turn(2);
                // // z.getImage().setTransparency(z.getImage().getTransparency() - Greenfoot.getRandomNumber(2));
                // z.getImage().setTransparency(110);
                // this.warten(1);

                // }
                // this.warten(1);
                // this.missionEnde("Zirkonplatte war instabil - unkontrollierte Resonanzentladung. #FAIL", "EXPLOSION");
            } else {
                Sound.play("BATTERYEATEN");
                this.anzahlZirkonplatten++;
                this.removeTouching(Zirkonplatte.class);
            }
        } else {
            this.missionEnde("Kein Zirkonplatte zum Aufnehmen. Peetie stürzt in einer Endlosschleife ab.", "ENDLOSSCHLEIFE");
        }
    }

    /** Wenn Peetie auf einer Zirkonplatte steht, wird true zurückgegeben. */
    public boolean zirkonplatteWirdBeruehrt() {

        return this.isTouching(Zirkonplatte.class);
    }

    /** Wenn die Zirkonplatte instabil ist, wird true zurückgegeben. */
    public boolean zirkonplatteIstInstabil() {
        if(!this.aktuellesSzenarioString.equals("e7m1") || !this.aktuellesSzenarioString.equals("e7m2")) { // in e7m1 + e7m2 ignorieren wir, dass manche Zirkonplatten instabil sind
            Zirkonplatte z = (Zirkonplatte)getOneIntersectingObject(Zirkonplatte.class);
            if(z != null) {
                return z.getIstInstabil();
            } else {
                missionEnde("Instabilitätsüberprüfung an leerer Stelle führte zu Energieschock. #FAIL", "EXPLOSION");
            }
        } 
        return false;
    }

    /**
     * Wenn Peetie eine Zirkonplatte bei sich trägt, wird true zurückgegeben.
     */
    public boolean peetieHatZirkonplatte() {
        return this.anzahlZirkonplatten == 1;
    }

    /**
     * Peetie legt eine Zirkonplatte ab, aber nur dann, wenn er zuvor mindestens eine aufgenommen hat.
     * 
     */
    public void zirkonplatteAblegen() {
        if(this.anzahlZirkonplatten > 0) {
            // if(this.isTouching(Zirkonplatte.class)) {
            // this.missionEnde("Hier lag schon eine Platte. #FAIL", "EXPLOSION");

            // } else {
            this.mars.addObject(new Zirkonplatte(), this.getX(), this.getY());
            this.anzahlZirkonplatten--;
            this.warten(20);
            // }
        } else {
            this.missionEnde("Keine Zirkonplatte im Inventar. Peetie stürzt ab. #FAIL", "EXPLOSION");
        }
    }
    /**
     * #################### TASTATUR & FIGHT ######################
     */

    /**
     * Wenn die als Parameter übergebene Taste gedrueckt ist, wird true zurückgegeben.
     *
     * @param t Die Taste, die geprüft wird.
     *
     * <p>Beispielverwendung: {@code if(tasteGedrueckt("left"))<br>textAusgeben("Pfeil links gedrückt!")}
     *
     */
    public boolean tasteGedrueckt(String taste) {
        if(Greenfoot.isKeyDown(taste)) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * Wenn die Leertaste gedrückt ist, wird true zurückgegeben.
     *
     * <p>Beispielverwendung: {@code if(leertasteGedrueckt())<br>raketeAbfeuern()}
     *
     */
    public boolean leertasteGedrueckt() {
        boolean canFireRocket = this.rocketDelayCounter <= 0 && this.getWorld().getObjects(Rakete.class).size() == 0;

        if (Greenfoot.isKeyDown("space")) {
            if (canFireRocket) {
                // Nur eine Rakete abfeuern, wenn die Taste nicht gedrückt war
                if (!isSpacePressed) {
                    isSpacePressed = true;
                    this.getImage().setTransparency(255); // Volle Sichtbarkeit, wenn bereit
                    return true;  // Rakete abfeuern
                }
            } else {
                // Kann keine Rakete abfeuern: Transparenz und Sound fürs Laden
                this.getImage().setTransparency(Greenfoot.getRandomNumber(80) + 40); 
                Sound.play("LOADING");
            }
        } else {
            isSpacePressed = false;  // Taste wurde losgelassen
        }

        // Transparenz zurücksetzen, wenn bereit, wieder eine Rakete abzufeuern
        if (canFireRocket) {
            this.getImage().setTransparency(255); // Sichtbar, wenn keine Rakete mehr in der Welt ist
        }

        return false;
    }

    /**
     * Wenn die linke Maustaste gedrückt ist, wird true zurückgegeben.
     * 
     * <p>Beispielverwendung: {@code if(maustasteGedrueckt())<br>raketeAbfeuern()}
     */
    public boolean maustasteGedrueckt() {
        return Greenfoot.mouseClicked(null);
    }

    /** Feuert eine Rakete ab. Es kann immer nur eine Rakete auf der Welt sein. */
    public void raketeAbfeuern() {
        if(this.rocketDelayCounter <= 0 || this.getWorld().getObjects(Rakete.class).size() == 0) {
            Rakete r = new Rakete();
            Sound.play("MISSILE");
            this.getWorld().addObject(r, this.getX(), this.getY() - 25);
            this.rocketDelayCounter = this.rocketDelay; 
        }
    }

    /** Wenn eine feindliches Objekt (Drohne, Asteroid …) zerstört wurde, wird true zurückgegeben. */

    public boolean objektWurdeAbgeschossen() {
        if(this.objectShotDown) {
            this.objectShotDown = false;
            return true;
        } else {
            return false;
        }
    }

    /** Wenn Peetie von einem Gegenstand (Drohnenbombe, Schrott …) getroffen wurde, wird true zurückgegeben. */
    public boolean peetieWurdeGetroffen() {
        if(this.ptWasHit) {
            this.ptWasHit = false;
            return true;
        } else {
            return false;
        }
    }

    /*
     * ################### RUMBALLERN ##########################
     */
    public void _setObjectShotDown(boolean d) {
        this.objectShotDown = d;
    }
    /**
     * #################### EINFACHE TEXTAUSGABE ######################
     */
    /**
     * Gibt eine Zeichenkette oben in der Weltmitte (bzw. in den Smartphone-Missionen auf dem Smartphone) aus.
     *
     * @param t Die auszugebende Zeichenkette
     *
     * <p><p>Beispielverwendung: {@code textAusgeben("Hallo")}
     * <p>Beispielverwendung: {@code textAusgeben("Munition: " + munition)}
     * <p>Beispielverwendung: {@code textAusgeben(automarke)}
     * 
     * <p><p>Achtung: Andere Datentypen (bspw. int/Ganzzahl) können so nicht ausgegeben werden. Es funktioniert also NICHT
     * {@code textAusgeben(munition)}!
     * <p><p>Du musst die Zahl in diesem Fall in einen String umwandeln. Dazu hast du folgende Möglichkeiten:
     * <p>Die Zahl mit einem String verknüpfen - das wird dann ein String:
     * <p>{@code textAusgeben("Munition: " + munition)} - die Ausgabe »Munition: 23« ist ein String.
     * <p>Du kannst auch einen leeren String verwenden, z.B. {@code textAusgeben(munition + "")} - verbindet den Wert von munition und den leeren String zu einem String.
     * <p><p>Wenn du ganz professionell sein willst, kannst du die Zahl auch in einen String konvertieren mit {@code textAusgeben(Integer.toString(munition))} oder {@code textAusgeben(Double.toString(ergebnisAlsDezimalzahl))}
     */
    public void textAusgeben(String t) { // Für Smartphone-Szenarien
        if(this.szenarioArt.equals("3-smartphone")) {
            this.mars.removeObject(this.lblTextausgabe);
            this.lblTextausgabe = new Label();
            GreenfootImage g = new GreenfootImage(t, 30, new Color(212, 15, 15), new Color(196, 194, 196));
            this.lblTextausgabe.setImage(g);
            int startX = 100;
            this.mars.addObject(this.lblTextausgabe, startX, 450);
            for(int x = startX; x <= this.mars.getWidth()/2; x += 8) {
                this.lblTextausgabe.setLocation(x, 400);
                this.warten(1);
            }
            this.warten(200);
        } else { // Für die anderen Szenarien
            this.getWorld().showText(t, this.getWorld().getWidth()/2, 150);
        }
    }
    /**
     * #################### TEXTAUSGABE an BESTIMMTER POSITION ######################
     */
    /**
     * Fortgeschritten: Gibt eine Zeichenkette an der gewünschten Position aus.
     *
     * @param t Die auszugebende Zeichenkette
     * @param x Die x-Position (0 ist ganz links)
     * @param y Die y-Position (0 ist oben)
     *
     * <p>Beispielverwendung: {@code textAusgeben("Hallo", 200, 100)}
     * <p>Beispielverwendung: {@code textAusgeben("Verbleibende Munition: " + munition, 150, 50)}
     * <p>Beispielverwendung: {@code textAusgeben(automarke, 150, 50)}
     */
    public void textAusgeben(String t, int x, int y) {
        this.getWorld().showText(t, x, y);
    }
    /**
     * #################### TEXT EINLESEN / AUSGEBEN ######################
     */

    /** Liest eine Zeichenkette ein
     * 
     * <p>Beispiel: {@code nachname = einlesen()}
     * <p>Dann öffnet sich ein Eingabedialog, und der/die User kann einen Wert eingeben. Dieser Wert wird der Variablen nachname zugewiesen.
     * <p>Die Variable muss natürlich vorher deklariert worden sein. 
     */
    public String einlesenZeichenkette() {
        return Greenfoot.ask("");
    }

    /** Liest eine Dezimalzahl ein
     * 
     * <p>Beispiel: {@code zinssatz = einlesen()}
     */
    public double einlesenDezimalzahl() {
        return Double.parseDouble(this.einlesenZeichenkette());
    }

    /** Liest eine Ganzzahl ein
     * 
     * <p>Beispiel: {@code alter = einlesen()}
     */
    public int einlesenGanzzahl() {
        return Integer.parseInt(this.einlesenZeichenkette());
    }

    /* 
     * #########################################################
     * #########################################################
     * ################# PRIVATE METHODEN ######################
     * #########################################################
     * #########################################################
     * werden von Standard-Methoden benutzt,
     * werden aber von Schüler/innen nicht benutzt 
     * 
     */
    private void bewegen(int neueAusrichtung, String neuesBild, int bildRotation, String sound) {
        if(!this.missionAccomplished) {
            this.setRotation(neueAusrichtung);
            this.setImage(neuesBild);
            this.getImage().rotate(bildRotation);
            if(this.szenarioArt.equals("1-statisch")) {
                this.move(this.gridSize);
                Sound.play(sound);
                this.checkCollisions();
                this.warten(); 
            } else if(this.szenarioArt.equals("2-dynamisch")){
                this.move(this.ptSpeed);
                Sound.play(sound);}
        }
    }

    private void checkCollisions() {
        // Verwaltet automatisches Einsammeln von Batterien etc. und destruktive Kollisionen mit Felsen usw.
        // Je nach Szenario können einzelne Kollisionsprüfungen abgeschaltet werden (auskommentieren):
        // this.checkBasisErreicht();
        this.checkHolomarkerErreicht();
        this.checkFelsKollision();
        this.checkKraterKollision();
        this.checkPeetieBruchstueckKollision();
        this.checkBatterieKollision();
        this.checkTruemmerteilKollision();
        this.checkSiegbedingungen();
    }

    private void setDxDy() { // Ermittelt Offset zum nächsten Objekt in Blickrichtung
        this.dx = 0;
        this.dy = 0;
        switch(this.getRotation()) {
            case 0: // rechts
                this.dx = this.gridSize;
                break;
            case 180: // links
                this.dx = -this.gridSize;
                break;
            case 90: // unten
                this.dy = this.gridSize;
                break;
            case 270: // oben
                this.dy = -this.gridSize;
                break;
            default:
                break;

        }
    }

    private boolean istObjektVoraus(Class c) {
        this.setDxDy();
        if(this.getOneObjectAtOffset(this.dx, this.dy, c) != null) {
            return true;
        } else {
            return false;
        }
    }

    private void checkPeetieBruchstueckKollision() {
        if(this.isTouching(PeetieBruchstueck.class)) {
            PeetieBruchstueck pb = (PeetieBruchstueck)this.getOneIntersectingObject(PeetieBruchstueck.class);
            this.missionEnde(pb.getBezeichnung() + " gefunden!", "YEAH!");
        }
    }

    private void checkBatterieKollision() {
        if(this.isTouching(Batterie.class)) {
            Sound.play("BATTERYEATEN");
            this.removeTouching(Batterie.class);
            if(alleBatterienGesammelt()) 
            { 
                if(this.aktuellesSzenarioString.equals("e1m3")) {
                    // hier reicht es nicht, alle batterien gesammelt zu haben, man muss auch noch das trümmerfeld verlassen haben
                } else {
                    this.missionEnde("Alle Batterien gesammelt, perfekt!", "YEAH!");
                }
            }
        }
    }

    private boolean alleBatterienGesammelt() {
        List<Batterie> batterienAufWelt = this.getWorld().getObjects(Batterie.class);
        return batterienAufWelt.size() <= 0 ? true : false;
    }

    private boolean alleRaketenGesammelt() {
        List<Rakete> raketenAufWelt = this.getWorld().getObjects(Rakete.class);
        return raketenAufWelt.size() <= 0 ? true : false;
    }

    private void checkTruemmerteilKollision() {
        if(this.isTouching(Truemmerteil.class)) {
            this.removeTouching(Truemmerteil.class);
            this.missionEnde("KOLLIDIERT MIT TRUEMMERTEIL!! #FAIL", "EXPLOSION");
        }
    }

    private void checkKraterKollision() {
        if(this.isTouching(Krater.class)) {
            this.removeTouching(Krater.class);
            this.missionEnde("IN EINEN KRATER GESTÜRZT … #FAIL", "ABSTURZ");
        }
    }

    private void checkFelsKollision() {
        if(this.isTouching(Fels.class)) {
            this.removeTouching(Fels.class);
            this.missionEnde("VOLL AUF DEN FELSEN GEPRALLT! #FAIL", "STEINSCHLAG");
        }
    }

    /*
     * In einigen Szenarien gibt es zusätzliche Bedingungen, damit das Szenario beendet wird (bspw. e1m3) -
     * die werden hier abgefragt.
     */
    private void checkSiegbedingungen() {
        // System.out.println(this.aktuellesSzenario);
        if(this.aktuellesSzenarioString.equals("e1m3")) {
            if(this.alleBatterienGesammelt() && this.getY() > 400) {
                this.missionEnde("Perfekt durchs Trümmerfeld und die Batterie mitgenommen!", "YEAH!");

            }
        }
    }

    private void missionEnde(String spruch, String sound) {
        this.missionAccomplished = true;
        this.warten(8);
        Sound.play(sound);
        this.getWorld().showText(spruch, this.mars.getWidth()/2, this.mars.getHeight()/2);
        this.warten(50);
        Sound.stopAll();
        Greenfoot.stop();
        this.warten(20);
    }

    /**
     * #################### FEINDLICHE BASIS ANGREIFEN ######################
     */
    /*   private void checkBasisErreicht() {
    if(this.isTouching(Basis.class)) {
    this.arrivedAtBase = true;
    this.missionEnde("Peetie hat die Basis gefunden und alle Felsen umrundet - #sauber!", "YEAH!");
    } else {
    this.arrivedAtBase = false;
    }
    } */

    /**
     * #################### HOLOMARKER CHECK ######################
     */
    private void checkHolomarkerErreicht() {
        if(this.isTouching(Holomarker.class)) {
            this.arrivedAtHolomarker = true;
            if(!this.aktuellesSzenarioString.startsWith("e7")) { // in e7-Szenarien ist der Holomarker nur Markierung
                this.missionEnde("Peetie ist beim Holomarker angekommen - #sauber!", "YEAH!");
            }
        } else {
            this.arrivedAtHolomarker = false;
        }
    }

    /**
     * ###################### FIGHT and SHOOT private ###############
     */
    private void checkIfPeetieWasHit() {
        if(this.isTouching(Drohnenbombe.class) || this.isTouching(Schrott.class)) {
            GreenfootImage bildAlt = this.getImage();
            int rotation = this.getRotation();
            this.ptWasHit = true;
            this.setImage("peetie_runter_50_verformt.png");
            this.setRotation(0);
            Sound.play("SMALLHIT");
            this.warten(8);
            this.setImage(bildAlt);
            this.setRotation(rotation);
            this.removeTouching(Item.class);
        }
    }

    private void ptCheckCollisionWithDrone() {
        if(this.isTouching(Gegner.class)) {
            this.setImage("explosiongelb_100.png");

            //  this.systemnachricht("Peetie wurde gerammt und ist explodiert! #FAIL");
            // Sound.play("EXPLOSION");
            this.missionEnde("Peetie wurde gerammt und ist explodiert! #FAIL", "EXPLOSION");
            Greenfoot.stop();
        }
    }

    /* Andere Methoden, die Schüler/innen nicht brauchen: */
    public void _run() {
        // Wird in Peetie überschrieben
    }

    private void warten() {
        Greenfoot.delay(this.delay);
    }

    private void warten(int del) {
        Greenfoot.delay(del);
    }

    /* Getter, Setter */

}