import greenfoot.*;
import java.util.*;

/**
 * Hier werden die Spezifika der einzelnen Szenarien verwaltet (bspw. Startposition Peetie, Anordnung der Objekte etc.)
 */
public class SzenarioKonfigurator {
    public static SzenarioTyp szenarioNr; // im Format e1m3
    public static String szenarioArt = "1-statisch";
    // 1-statisch, 2-dynamisch, 3-smartphone
    public static String gegnertyp = "";
    // kampfdrohnen, scoutdrohnen, asteroiden, schrott
    // relevant für die act-Methode in Mars

    // AI_Robot
    public static String peetieDefaultImage = "peetie_runter_50.png";
    public static Integer peetieStartposX;
    public static Integer peetieStartposY;
    public static Integer peetieDirection;
    public static int delay = 25; // in statischen Szenarien (z.B. Batteriensammeln) - wie lange wartet Peetie zwischen einzelnen geheRechts-Aktionen etc.
    public static int ptSpeed = 5; // in dynamischen Szenarien (z.B. auf Drohnen ballern)
    public static int quarzX = 225;
    public static int quarzY = 125;
    public static int anzahlZirkonplatten = 0;

    // World
    public static String worldBackgroundImageFilename = "marsoberflaeche-960.jpg";
    public static int worldWidth = 960;
    public static int worldHeight = 640;

    // Label
    public static String titel = "Episodentitel";
    public static int episode;
    public static int mission;
    public static String anleitungstext;

    // Missionentitel für den Startscreen
    private static final Map<SzenarioTyp, String> szenarioTitelMap = new HashMap<>();
    static {
        szenarioTitelMap.put(SzenarioTyp.e1m1, "Need Batteries");
        szenarioTitelMap.put(SzenarioTyp.e1m2, "Trümmeralarm!");
        szenarioTitelMap.put(SzenarioTyp.e1m3, "Im Trümmerfeld");
        
        szenarioTitelMap.put(SzenarioTyp.e2m1, "Alle auf einmal");
        szenarioTitelMap.put(SzenarioTyp.e2m2, "Triebwerksuche");
        szenarioTitelMap.put(SzenarioTyp.e2m3, "Treibstofftank");
        szenarioTitelMap.put(SzenarioTyp.e2m4, "Ein Geschenk");
        
        szenarioTitelMap.put(SzenarioTyp.e3m1, "Die Felswüste");
        szenarioTitelMap.put(SzenarioTyp.e3m2, "Viele Krater");
        szenarioTitelMap.put(SzenarioTyp.e3m3, "Raketensammler");
        szenarioTitelMap.put(SzenarioTyp.e3m4, "SyberDrone-Minen");
        szenarioTitelMap.put(SzenarioTyp.e3m5, "Angriff auf PT98");
        
        szenarioTitelMap.put(SzenarioTyp.e4m1, "Schrotteile zählen");
        szenarioTitelMap.put(SzenarioTyp.e4m2, "Schrott-Alarm");
        szenarioTitelMap.put(SzenarioTyp.e4m3, "Fight back!");
        szenarioTitelMap.put(SzenarioTyp.e4m4, "Raketen sparen");
        szenarioTitelMap.put(SzenarioTyp.e4m5, "Drohnen-Stats");  
        szenarioTitelMap.put(SzenarioTyp.e4m6, "Kompliziert …");
        szenarioTitelMap.put(SzenarioTyp.e4m7, "Verschachtelt");
        szenarioTitelMap.put(SzenarioTyp.e4m8, "&&");
        szenarioTitelMap.put(SzenarioTyp.e4m9, "&& und ||");
        
        szenarioTitelMap.put(SzenarioTyp.e5m1, "While-Test");
        szenarioTitelMap.put(SzenarioTyp.e5m2, "Buddeln");
        szenarioTitelMap.put(SzenarioTyp.e5m3, "Buddeln auf Zeit");
        szenarioTitelMap.put(SzenarioTyp.e5m4, "Zum Holomarker");
        szenarioTitelMap.put(SzenarioTyp.e5m5, "Die Felswand");
        szenarioTitelMap.put(SzenarioTyp.e5m6, "Eingestürzt!");
        szenarioTitelMap.put(SzenarioTyp.e5m7, "In der Eishöhle");

        szenarioTitelMap.put(SzenarioTyp.e6m1, "Passwort-Fake");
        szenarioTitelMap.put(SzenarioTyp.e6m2, "Username, bitte!");
        szenarioTitelMap.put(SzenarioTyp.e6m3, "Ein Captcha");
        szenarioTitelMap.put(SzenarioTyp.e6m4, "Peeties Reset");
        szenarioTitelMap.put(SzenarioTyp.e6m5, "Berechnungen");
        
        szenarioTitelMap.put(SzenarioTyp.e7m1, "Zirkonplatte");
        szenarioTitelMap.put(SzenarioTyp.e7m2, "Easy mit Unterprogramm");
        szenarioTitelMap.put(SzenarioTyp.e7m3, "Instabile Matrix");
        szenarioTitelMap.put(SzenarioTyp.e7m4, "Perpeetium Mobile");
        szenarioTitelMap.put(SzenarioTyp.e7m5, "Leistung berechnen");
        szenarioTitelMap.put(SzenarioTyp.e7m6, "Rückgabewert");
        szenarioTitelMap.put(SzenarioTyp.e7m7, "T - 10 seconds!");

        
    }

    public static String getTitel(SzenarioTyp szenario) {
        return szenarioTitelMap.getOrDefault(szenario, "Unbekannter Titel");
    }

    // Sound
    // ! Auf false setzen, um Sound per default abzuschalten
    public static boolean soundIsOn = true;

    /*
     * Spezifisches Szenario initialisieren
     * Hier werden den statischen Feldern in SzenarioKonfigurator Werte zugewiesen.
     * Diese Werte holt sich dann die Welt (Mars) bzw. Peetie.
     */
    public static void initialisiereSzenario(SzenarioTyp szenario) {
        // Defaultwerte für Variablen, die nicht explizit initialisiert werden
        worldWidth = 960;
        worldHeight = 640;
        worldBackgroundImageFilename = "marsoberflaeche-960.jpg";
        szenarioArt = "1-statisch";
        gegnertyp = "";
        szenarioNr = szenario;
        anzahlZirkonplatten = 0;

        switch(szenario) {
            case e1m1:
                // Label (Help-Text)
                titel = "Batterien sammeln";
                episode = 1;
                mission = 1;
                anleitungstext = """
                Schreibe in der Klasse Peetie in _run() ein Programm,
                mit dem Peetie alle Batterien einsammelt.
                """;

                // Peetie
                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 375;
                peetieStartposY = 125;
                peetieDirection = 0;
                delay = 40;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-aerial-bergstrukturen.jpg";
                break;

            case e1m2:
                // Label (Help-Text)
                titel = "Trümmern ausweichen";
                episode = 1;
                mission = 2;
                anleitungstext = """
                Programmiere eine Lösung, mit der es Peetie gelingt,
                die Energiezellen aufzusammeln, ohne dass er dabei
                durch die explosiven Trümmer zerstört wird!
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 425;
                peetieStartposY = 225;
                peetieDirection = 0;
                delay = 40;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-aerial-bergstrukturen.jpg";
                break;

            case e1m3:
                // Label (Help-Text)
                episode = 1;
                mission = 3;
                anleitungstext = """
                Ändere das Struktogramm so, dass Peetie die Batterie einsammelt
                und das Trümmerfeld im Süden verlässt, ohne ein Trümmerteil
                zu berühren.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 875;
                peetieStartposY = 25;
                peetieDirection = 0;
                delay = 40;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-bird.jpg";
                break;

            case e2m1:
                // Label (Help-Text)
                episode = 2;
                mission = 1;
                anleitungstext = """
                Schreibe ein Programm, das Peetie alle
                Batterien einsammeln lässt.
                
                Verwende dazu eine Zählerschleife.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 125;
                peetieStartposY = 475;
                peetieDirection = 0;
                delay = 40;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-flat-aerial-steger.jpg";
                break;

            case e2m2:
                // Label (Help-Text)
                episode = 2;
                mission = 2;
                anleitungstext = """
                Ein Programm schreiben, mit dem Peetie das
                Triebwerk auf jeden Fall findet.
                Das Triebwerk ist etwa doppelt so groß wie
                Peetie und liegt in Nord-Süd-Richtung.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 25;
                peetieStartposY = 75;
                peetieDirection = 0;
                delay = 20;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "marsoberflaeche-960.jpg";
                worldWidth = 900;
                worldHeight = 250;
                break;

            case e2m3:
                // Label (Help-Text)
                episode = 2;
                mission = 3;
                anleitungstext = """
                Implementiere die Vorgaben aus dem Struktogramm bei Peetie.
                Teste das Programm, ob der Treibstofftank in jedem
                Fall gefunden wird.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 25;
                peetieStartposY = 25;
                peetieDirection = 0;
                delay = 9;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "marsoberflaeche-960.jpg";
                worldWidth = 350;
                worldHeight = 600;
                break;

            case e2m4:
                // Label (Help-Text)
                episode = 2;
                mission = 4;
                anleitungstext = """
                Entwickle ein Struktogramm, mit dem Peetie ein »D« in 
                den Sand schreibt.
                
                Wenn du fertig bist, lass es von anderen Programmierer/innen
                kontrollieren.
                Danach implementiere es bei Peetie.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 275;
                peetieStartposY = 575;
                peetieDirection = 0;
                delay = 15;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars_rund_900x600.jpg";
                break;

            case e3m1:
                // Label (Help-Text)
                episode = 3;
                mission = 1;
                anleitungstext = """
                Programmiere in Peeties _run()-Funktion, dass Peetie alle
                Batterien aufsammelt, aber nicht gegen Felsen stößt.
                
                Verwende dazu eine if-Verzweigung und den Befehl istFelsVoraus().
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 825;
                peetieStartposY = 275;
                peetieDirection = 0;
                delay = 25;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-aerial-feindliche-felsen.jpg";
                break;

            case e3m2:
                // Label (Help-Text)
                episode = 3;
                mission = 2;
                anleitungstext = """
                Schreibe ein Programm, mit dem Peetie alle Batterien
                aufsammelt. Diesmal muss er jedoch nicht nur die Felsen,
                sondern auch die Krater umgehen!
                
                Verwende istFelsVoraus(), istKraterVoraus()
                
                ODER machen wir mit ||, UND machen wir mit &&
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 75;
                peetieStartposY = 275;
                peetieDirection = 0;
                delay = 25;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-felsen-wueste-nebel.jpg";
                break;

            case e3m3:
                // Label (Help-Text)
                episode = 3;
                mission = 3;
                anleitungstext = """
                Peetie soll alle Raketen einsammeln. Er muss prüfen,
                ob er eine Rakete berührt - wenn ja, soll er sie
                aufnehmen.
                
                Befehle: raketeWirdBeruehrt(); raketeAufnehmen()
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 775;
                peetieStartposY = 175;
                peetieDirection = 0;
                delay = 25;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-aerial-nasa.jpg";
                break;

            case e3m4:
                // Label (Help-Text)
                episode = 3;
                mission = 4;
                anleitungstext = """
                Entwickle ein Struktogramm:
                Peetie soll die Raketen sammeln. Wenn er eine Rakete
                berührt, soll er vor dem Aufnehmen prüfen, ob sie sicher
                ist mit if(raketeIstSicher()) …. Wenn sie nicht sicher ist,
                muss er sie entschärfen mit entschaerfen() und dann 
                erst aufnehmen.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 125;
                peetieStartposY = 225;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-aerial-nasa.jpg";
                break;

            case e3m5:
                szenarioArt = "2-dynamisch";
                gegnertyp = "scoutdrohnen";
                // Label (Help-Text)
                episode = 3;
                mission = 5;
                anleitungstext = """
                Implementiere eine Tastatursteuerung:
                Leertaste gedrückt --> Rakete wird abgefeuert.
                Taste a und d: Peetie fährt links/rechts
                
                Befehle: leertasteIstGedrueckt, raketeAbfeuern,
                tasteGedrueckt("right") - !: Anführungszeichen
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = worldWidth/2;
                peetieStartposY = worldHeight - 50;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-wueste-felsen.jpg";    
                break;

            case e4m1:
                szenarioArt = "2-dynamisch";
                gegnertyp = "schrott";
                // Label (Help-Text)
                episode = 4;
                mission = 1;
                anleitungstext = """
                Programmieren: Zähle, wie viele Schrotteile Peetie
                getroffen haben und gib die Zahl aus.
                
                Benutze eine neue Variable (z.B. anzahl)
                und if(peetieWurdeGetroffen()) …
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = worldWidth/2;
                peetieStartposY = worldHeight - 50;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-wueste-felsen.jpg";    
                break;

            case e4m2:
                szenarioArt = "2-dynamisch";
                gegnertyp = "schrott";
                // Label (Help-Text)
                episode = 4;
                mission = 2;
                anleitungstext = """
                Wenn die Anzahl der Schrotteile, die Peetie getroffen
                haben, 5 erreicht, muss »Kritisch« ausgegeben werden.
                Bei 10 und mehr muss »ALARM!!!« ausgegeben werden.
                
                Ein Struktogramm dafür liegt dir schon vor.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = worldWidth/2;
                peetieStartposY = worldHeight - 50;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-wueste-felsen.jpg";    
                break;

            case e4m3:
                szenarioArt = "2-dynamisch";
                gegnertyp = "schrott";
                // Label (Help-Text)
                episode = 4;
                mission = 3;
                anleitungstext = """
                Peetie muss sich bewegen und Raketen abschießen können.
                Peetie soll zählen, wie viele Raketen er
                abgefeuert hat und wie oft er von Schrottteilen getroffen
                wurde.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = worldWidth/2;
                peetieStartposY = worldHeight - 50;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-wueste-felsen.jpg";    
                break;

            case e4m4:
                szenarioArt = "2-dynamisch";
                gegnertyp = "schrott";
                // Label (Help-Text)
                episode = 4;
                mission = 4;
                anleitungstext = """
                Vervollständige das Struktogramm:
                Peetie hat 41 Raketen. Wenn er mehr als 30 Raketen
                hat, kann er feuern, ansonsten nicht.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = worldWidth/2;
                peetieStartposY = worldHeight - 50;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-wueste-felsen.jpg";    
                break;

            case e4m5:
                szenarioArt = "2-dynamisch";
                gegnertyp = "kampfdrohnen";
                // Label (Help-Text)
                episode = 4;
                mission = 5;
                anleitungstext = """
                Peetie kämpft gegen die Drohnen.
                Er muss zählen, wie oft er getroffen wurde und wie viele
                Drohnen er zerstört hat. Außerdem muss er seine Munition
                unter Kontrolle behalten - er kann natürlich nur
                schießen, so lange er noch Munition hat.
                Am Anfang hat er 20 Schüsse.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = worldWidth/2;
                peetieStartposY = worldHeight - 50;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-dunstig-horizont-felsen.jpg";    
                break;

            case e4m6:
                szenarioArt = "2-dynamisch";
                gegnertyp = "kampfdrohnen";
                // Label (Help-Text)
                episode = 4;
                mission = 6;
                anleitungstext = """
                Implementiere das Struktogramm von Dragan.
                War E4M03
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = worldWidth/2;
                peetieStartposY = worldHeight - 50;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-dunstig-horizont-felsen.jpg";    
                break;

            case e4m7:
                szenarioArt = "2-dynamisch";
                gegnertyp = "kampfdrohnen";
                // Label (Help-Text)
                episode = 4;
                mission = 7;
                anleitungstext = """
                Verschachtelte Verzweigungen
                Implementiere das Struktogramm von Dragan
                War E4M04
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = worldWidth/2;
                peetieStartposY = worldHeight - 50;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-dunstig-horizont-felsen.jpg";    
                break;

            case e4m8:
                szenarioArt = "2-dynamisch";
                gegnertyp = "kampfdrohnen";
                // Label (Help-Text)
                episode = 4;
                mission = 8;
                anleitungstext = """
                Bedingungen in Verzweigungen
                Implementiere das Struktogramm von Dragan
                War E4M05
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = worldWidth/2;
                peetieStartposY = worldHeight - 50;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-dunstig-horizont-felsen.jpg";    
                break;

            case e4m9:
                szenarioArt = "2-dynamisch";
                gegnertyp = "kampfdrohnen";
                // Label (Help-Text)
                episode = 4;
                mission = 9;
                anleitungstext = """
                Bedingungen in Verzweigungen
                Implementiere das Struktogramm von Dragan
                War E4M06
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = worldWidth/2;
                peetieStartposY = worldHeight - 50;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-dunstig-horizont-felsen.jpg";    
                break;

            case e5m1:
                // Label (Help-Text)
                episode = 5;
                mission = 1;
                anleitungstext = """
                Peetie muss sich 10 Schritte weit bewegen. Teste, ob das
                mit einer kopfgesteuerten Schleife klappt.
                Implementiere die While-Schleife aus dem Struktogramm.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 825;
                peetieStartposY = 475;
                peetieDirection = 0;
                delay = 50;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-aerial-wolken-high.jpg";    
                break;

            case e5m2:
                // Label (Help-Text)
                episode = 5;
                mission = 2;
                anleitungstext = """
                Peetie soll 5 Löcher nebeneinander buddeln,
                damit der Sand nachgibt.
                Verwende dafür eine While-Schleife.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 325;
                peetieStartposY = 275;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-aerial-felsenkette.jpg";    
                break;

            case e5m3:
                // Label (Help-Text)
                episode = 5;
                mission = 3;
                anleitungstext = """
                Peetie soll 73 Stunden lang an Löcher nebeinander
                graben. Für jedes Loch braucht er genau zwei
                Stunden.
                Er soll mitzählen, wie viele Löcher er gräbt und 
                am Schluss das Ergebnis ausgeben.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 125;
                peetieStartposY = 275;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-mars-aerial-felsenkette.jpg";    
                break;

            case e5m4:
                // Label (Help-Text)
                episode = 5;
                mission = 4;
                anleitungstext = """
                Peetie soll so lange durch die Höhle gehen, bis er
                den Holomarker erreicht hat.
                Aufpassen - alles voller Krater!
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 875;
                peetieStartposY = 525;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-hoehle-dark.jpg";    
                break;

            case e5m5:
                // Label (Help-Text)
                episode = 5;
                mission = 5;
                anleitungstext = """
                Peetie muss an der Felsbarriere entlang gehen. Das Problem ist,
                dass er die Länge nicht kennt.
                Programmiere eine While-Schleife, mit der Peetie den Holomarker
                in jedem Fall erreicht!
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 875;
                peetieStartposY = 525;
                peetieDirection = 0;
                delay = 20;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-hoehle-dark.jpg";    
                break;

            case e5m6:
                // Label (Help-Text)
                episode = 5;
                mission = 6;
                anleitungstext = """
                Peetie muss um die Felsbarriere herumgehen. Das Problem ist, dass er
                die Länge nicht kennt.
                Programmiere eine While-Schleife, mit der Peetie den Holomarker
                in jedem Fall erreicht!
                
                Du solltest wieder den Befehl istFelsOben() verwenden. Evtl. musst du
                IN deine While-Schleife eine andere While-Schleife platzieren ;-)
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 875;
                peetieStartposY = 525;
                peetieDirection = 0;
                delay = 17;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-hoehle-dark.jpg";    
                break;

            case e5m7:
                // Label (Help-Text)
                episode = 5;
                mission = 6;
                anleitungstext = """
                Peetie muss durch die Eishöhle. Seine Betriebstemperatur
                ist 113 Grad, und er verliert pro Minute 14 Grad. Seine
                Temperatur darf nicht unter 8 Grad fallen!
                Er soll so lange laufen, bis er 8 Grad Temperatur erreicht hat.
                Dann bleibt er stehen.
                ZUSATZAUFGABE: Er kann auch stehen bleiben, wenn er den Holo-
                Marker erreicht hat.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 225;
                peetieStartposY = 425;
                peetieDirection = 0;
                delay = 60;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-eishoehle.jpg";    
                break;

            case e6m1:
                szenarioArt = "3-smartphone";

                // Label (Help-Text)
                episode = 6;
                mission = 1;
                anleitungstext = """
                Andy und Dragan versuchen ihre Feinde mit einem
                gefakten ChatGPT in die Irre zu führen.
                Setzen Sie das vorgegebene Struktogramm um.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 210;
                peetieStartposY = 290;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-smartphone-toilette.jpg";  
                break;

            case e6m2:
                szenarioArt = "3-smartphone";

                // Label (Help-Text)
                episode = 6;
                mission = 2;
                anleitungstext = """
                Der ChatGPT-Fake soll Username und Passwort entgegen
                nehmen. Wenn Username NICHT spirinspirin und Passwort 1234
                ist, kommt eine Fehlermeldung, ansonsten »Hallo Dragan«
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 210;
                peetieStartposY = 290;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-smartphone-toilette.jpg";  
                break;

            case e6m3:
                szenarioArt = "3-smartphone";

                // Label (Help-Text)
                episode = 6;
                mission = 3;
                anleitungstext = """
                Programmiere ein Captcha-Fake, wie in den 
                Screenshots gezeigt.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 210;
                peetieStartposY = 290;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-smartphone-toilette.jpg";  
                break;

            case e6m4:
                szenarioArt = "3-smartphone";

                // Label (Help-Text)
                episode = 6;
                mission = 4;
                anleitungstext = """
                Erzeuge ein Struktogramm, mit dem Gewicht und Triebwerkgewicht
                eingelesen werden.
                Du brauchst natürlich entsprechende Variablen, in denen
                die eingegebenen Werte gespeichert werden.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 210;
                peetieStartposY = 290;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-smartphone-toilette.jpg";  
                break;

            case e6m5:
                szenarioArt = "3-smartphone";

                // Label (Help-Text)
                episode = 6;
                mission = 5;
                anleitungstext = """
                Wir kennen Peeties Gewicht (3800kg)+ Triebwerksgewicht (1200kg).
                Eine Rakete wiegt 158kg.
                Eingabe der Anzahl der Raketen.
                Dann ausrechnen: Gesamtgewicht Peetie (Gewicht Peetie + Gewicht
                Triebwerk), Gesamtgewicht Raketen, Gesamtgewicht Peetie ohne Raketen.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 210;
                peetieStartposY = 290;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-smartphone-toilette.jpg";  
                break;
            case e7m1:
                // Label (Help-Text)
                episode = 7;
                mission = 1;
                anleitungstext = """
                Gehe zur Zirkonplatte und nimm sie auf (zirkonplatteAufnehmen()).
                Prüfe vorher, ob Peetie die Platte berührt.
                Dann geh zurück zum Startplatz und lege sie ab.
                Prüfe aber vorher, ob Peetie die Platte wirklich dabei hat
                (peetieHatZirkonplatte).
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 225;
                peetieStartposY = 375;
                peetieDirection = 0;
                delay = 20;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-startplatz.jpg";
                break;

            case e7m2:
                // Label (Help-Text)
                episode = 7;
                mission = 2;
                anleitungstext = """
                Erstelle Unterprogramme plattePruefenUndNehmen und plattePruefenUndAblegen.
                Die verwendest du dann in _run, also im Hauptprogramm! Teste die
                Funktionsweise, indem Peetie beide Platten holt und zum Abflugpunkt schleppt.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 225;
                peetieStartposY = 375;
                peetieDirection = 0;
                delay = 20;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-startplatz.jpg";
                break;

            case e7m3:
                // Label (Help-Text)
                episode = 7;
                mission = 3;
                anleitungstext = """
                Verwende Zählerschleifen, um die Holomarker abzulaufen.
                Erweitere das bisherige Unterprogramm so, dass vor dem Aufnehmen
                geprüft wird, ob die Platte instabil ist.
                Es ist nicht schlimm, wenn du eine oder zwei liegen lässt.
                Hauptsache, Peetie fliegt nicht in die Luft!
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 225;
                peetieStartposY = 375;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-startplatz.jpg";
                break;

            case e7m4:
                // Label (Help-Text)
                episode = 7;
                mission = 4;
                anleitungstext = """
                Peetie muss sich an verschiedenen Stellen unterschiedlich oft drehen
                und eine Textausgabe machen. Schreibe ein Unterprogramm »drehen(int anzahl)«,
                mit dem sich Peetie entsprechend oft dreht.
                Du kannst das Struktogramm von Andy benutzen!
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 125;
                peetieStartposY = 375;
                peetieDirection = 0;
                delay = 10;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-startplatz.jpg";
                break;

            case e7m5:
                szenarioArt = "3-smartphone";

                // Label (Help-Text)
                episode = 7;
                mission = 5;
                anleitungstext = """
                Schreibe ein Unterprogramm gesamtleistungBerechnen(int drehungen).
                Dieses Unterprogramm berechnet die Gesamtleistung und gibt sie aus.
                Die Anzahl der Drehungen liest du im Hauptprogramm (run) ein und
                gibst die Eingabe dann als Parameter an das Unterprogramm.
                """;

                peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 210;
                peetieStartposY = 290;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-smartphone-toilette.jpg";  
                break;

            case e7m6:
                szenarioArt = "3-smartphone";

                // Label (Help-Text)
                episode = 7;
                mission = 6;
                anleitungstext = """
                Das Unterprogramm gesamtleistungBerechnen(int drehungen) soll
                die Gesamtleistung nicht AUSGEBEN, sondern ZURÜCKGEBEN.
                Dann kannst du das Ergebnis des Unterprogramms direkt im Hauptprogramm
                verwenden mit 
                textAusgeben("Leistung: " + gesamtleistungBerechnen(24))
                """;

                peetieDefaultImage = "peetie_rechts_50.png";
                peetieStartposX = 210;
                peetieStartposY = 290;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-smartphone-toilette.jpg";  
                break;

            case e7m7:
                szenarioArt = "4-liftoff";
                
                // Label (Help-Text)
                episode = 7;
                mission = 7;
                anleitungstext = """
                Gib Peetie den Befehl zum Lift off (initiateStartSequence).
                """;

               peetieDefaultImage = "peetie_runter_50.png";
                peetieStartposX = 0; // 480;
                peetieStartposY = 536;
                peetieDirection = 0;
                delay = 30;
                ptSpeed = 5;

                // World
                worldBackgroundImageFilename = "bg-liftoff-1b.jpg";
                break;
            // case e7m8:
                // szenarioArt = "2-dynamisch";
                // gegnertyp = "asteroiden";

                // // Label (Help-Text)
                // episode = 7;
                // mission = 5;
                // anleitungstext = """
                // Unterteile das Programm für Peeties Landeanflug
                // in gute Unterprogramme
                // (wie E7M01)
                // """;

                // peetieDefaultImage = "peetie_runter_50.png";
                // peetieStartposX = 125;
                // peetieStartposY = 225;
                // peetieDirection = 0;
                // delay = 30;
                // ptSpeed = 5;

                // // World
                // worldBackgroundImageFilename = "bg-weltraum_sterne_schwarz.jpg";
                // break;
        }
    }

    // Neue Methode zur Verteilung der Objekte
    public static void objekteVerteilen(SzenarioTyp szenario, World w) {
        int xpos, ypos;

        switch(szenario) {
            case e1m1:
                w.addObject(new Batterie(), 375, 275);
                w.addObject(new Batterie(), 375, 325);
                w.addObject(new Batterie(), 475, 325);
                break;

            case e1m2:
                w.addObject(new Batterie(), 375, 275);
                w.addObject(new Batterie(), 375, 325);
                w.addObject(new Batterie(), 475, 375);
                w.addObject(new Truemmerteil(), 425, 325);
                w.addObject(new Truemmerteil(), 325, 375);
                w.addObject(new Truemmerteil(), 375, 375);
                break;

            case e1m3:
                for(int x = 25; x <= 850; x += 50) {
                    for(int y = 25; y <= 400; y += 50) {
                        w.addObject(new Truemmerteil(), x, y);
                    }
                }
                for(int x = 825; x >= 600; x -= 50) {
                    Truemmerteil t = (Truemmerteil)w.getObjectsAt(x, 225, null).get(0);
                    w.removeObject(t);
                }
                w.removeObject((Actor)w.getObjectsAt(625, 275, null).get(0));
                w.addObject(new Batterie(), 625, 275);
                w.removeObject((Actor)w.getObjectsAt(625, 325, null).get(0));
                w.removeObject((Actor)w.getObjectsAt(625, 375, null).get(0));
                break;

            case e2m1:
                for(int y = 225; y <= 475; y += 50) {
                    w.addObject(new Batterie(), 625, y);
                }

                for(int x = 575; x >= 225; x -= 50) {
                    w.addObject(new Batterie(), x, 475);
                }
                break;

            case e2m2:
                PeetieBruchstueck triebwerk = new PeetieBruchstueck("Triebwerk", "triebwerk_40x80.png");
                w.addObject(triebwerk, Greenfoot.getRandomNumber(w.getWidth() - 50) + 25, Greenfoot.getRandomNumber(w.getHeight() - 50) + 25);
                triebwerk.getImage().setTransparency(140);
                break;

            case e2m3:
                PeetieBruchstueck treibstofftank = new PeetieBruchstueck("Treibstofftank", "treibstofftank_150x100.png");
                w.addObject(treibstofftank, Greenfoot.getRandomNumber(w.getWidth() - 50) + 25, Greenfoot.getRandomNumber(w.getHeight() - 50) + 25);
                treibstofftank.getImage().setTransparency(150);
                break;

            case e2m4:
                // Hier könnten Objekte für Szenario e2m4 verteilt werden, falls nötig
                break;

            case e3m1:
                ypos = 275;
                xpos = 675;
                for(xpos = xpos; xpos >= 525; xpos -= 50) {
                    w.addObject(new Batterie(), xpos, ypos);
                    xpos -= 50;
                    w.addObject(new Fels(), xpos, ypos);
                    xpos -= 50;
                    w.addObject(new Batterie(), xpos, ypos);
                }
                w.addObject(new Batterie(), xpos, ypos);
                xpos -= 50;
                w.addObject(new Batterie(), xpos, ypos);
                for(xpos = xpos - 50; xpos >= 125; xpos -= 50) {
                    w.addObject(new Fels(), xpos, ypos);
                    xpos -= 50;
                    w.addObject(new Batterie(), xpos, ypos);
                }
                break;

            case e3m2:
                ypos = 275;
                w.addObject(new Batterie(), 175, ypos);
                w.addObject(new Krater(), 225, ypos);
                w.addObject(new Batterie(), 275, ypos);
                w.addObject(new Batterie(), 325, ypos);
                w.addObject(new Fels(), 375, ypos);
                w.addObject(new Batterie(), 425, ypos);
                w.addObject(new Batterie(), 475, ypos);
                w.addObject(new Batterie(), 525, ypos);
                w.addObject(new Fels(), 575, ypos);
                w.addObject(new Batterie(), 625, ypos);
                w.addObject(new Krater(), 725, ypos);
                w.addObject(new Fels(), 825, ypos);
                w.addObject(new Batterie(), 875, ypos);
                break;

            case e3m3:
                w.addObject(new Rakete(true), 575, 175);
                w.addObject(new Rakete(true), 375, 175);
                w.addObject(new Rakete(true), 375, 325);
                w.addObject(new Rakete(true), 375, 525);
                break;

            case e3m4:
                for(int i = 225; i <= 825; i += 50) {
                    w.addObject(new Rakete((Greenfoot.getRandomNumber(2) + 1) % 2 == 1), i, 225);
                }
                break;
            case e3m5:
                // nur ballern
                /*
                 * bei asteroid bswp.
                 *         this.addObject(new Erde(), 440, 20);
                this.addObject(new MonsterAsteroid(), 200,200);
                 */
                break;
            case e5m4:
                ypos = 525;
                for(int x = 775; x >= 225; x -= 50) {
                    if((Greenfoot.getRandomNumber(2)+1)%2 == 0) {
                        w.addObject(new Krater(), x, ypos);
                        x -= 50;
                    }
                }
                w.addObject(new Holomarker(), 125, ypos);
                break;
            case e5m5:

                // Ausgangswerte für Felsen und Lücken
                int startX = 25;
                int endX = 925;

                // Anzahl der Felsen berechnen
                int numberOfFelsen = (endX - startX) / 50 + 1;

                // Zufällige Positionen für die Lücken berechnen
                int lowerGapPosition = Greenfoot.getRandomNumber(numberOfFelsen * 2/ 3) + 1;  // Lücke in den ersten 2/3

                // Platzierung der Felsen
                for (int i = 1; i <= numberOfFelsen; i++) {

                    w.addObject(new Fels(), startX + (i - 1) * 50, 475);
                }

                // Entfernen des Felsens an den Lückenpositionen
                w.removeObjects(w.getObjectsAt(startX + (lowerGapPosition - 1) * 50, 475, Fels.class));
                w.addObject(new Holomarker(), startX + (lowerGapPosition - 1) * 50, 475);

                break;

            case e5m6:

                // Ausgangswerte für Felsen und Lücken
                startX = 25;
                endX = 925;
                int yPositionLower = 475;
                int yPositionUpper = 375; // 50 Pixel weiter oben, um Platz für Peetie zu lassen

                // Anzahl der Felsen berechnen
                numberOfFelsen = (endX - startX) / 50 + 1;

                // Zufällige Positionen für die Lücken berechnen
                lowerGapPosition = Greenfoot.getRandomNumber(numberOfFelsen / 2) + 1;  // Untere Lücke in der ersten Hälfte
                int upperGapPosition = numberOfFelsen / 2 + Greenfoot.getRandomNumber(numberOfFelsen / 2 - 1);  // Obere Lücke in der zweiten Hälfte
                // Platzierung der Felsen in beiden Reihen
                for (int i = 1; i <= numberOfFelsen; i++) {
                    w.addObject(new Fels(), startX + (i - 1) * 50, yPositionLower); // Felsen in der unteren Reihe
                    w.addObject(new Fels(), startX + (i - 1) * 50, yPositionUpper); // Felsen in der oberen Reihe
                }

                // Entfernen des Felsens an den Lückenpositionen
                w.removeObjects(w.getObjectsAt(startX + (lowerGapPosition - 1) * 50, yPositionLower, Fels.class));
                w.addObject(new Fels(), startX + (lowerGapPosition - 2) * 50, yPositionLower - 50);
                // Ziehen der dreier-Säule bis nach unten
                int yPosition = yPositionLower + 50 ;
                while (yPosition <= 575) {  // Diese Schleife zieht die Säule bis zum unteren Rand (y = 0)
                    w.addObject(new Fels(), startX + (lowerGapPosition - 2) * 50, yPosition);
                    yPosition += 50;
                }

                // Entfernen der Felsen links von der Säule
                for (int i = 1; i < lowerGapPosition - 1; i++) {
                    w.removeObjects(w.getObjectsAt(startX + (i - 1) * 50, yPositionLower, Fels.class));
                    w.removeObjects(w.getObjectsAt(startX + (i - 1) * 50, yPositionUpper, Fels.class));
                }

                // Entfernen des Felsens an der oberen Lücke und Platzierung des Holomarkers
                w.removeObjects(w.getObjectsAt(startX + (upperGapPosition - 1) * 50, yPositionUpper, Fels.class));
                w.addObject(new Holomarker(), startX + (upperGapPosition - 1) * 50, yPositionUpper);

                break;

            case e7m1: 
                w.addObject(new Zirkonplatte(), 325, 375);
                w.addObject(new Zirkonplatte(), 225, 475);

                break;
            case e7m2:
                w.addObject(new Zirkonplatte(), 325, 375);
                w.addObject(new Zirkonplatte(), 225, 475);
                break;
            case e7m3:
                w.addObject(new Holomarker(), 125, 375);
                w.addObject(new Holomarker(), 675, 375);
                // w.addObject(new Holomarker(), 675, 125);
                w.addObject(new Holomarker(), 225, 325);
                w.addObject(new Zirkonplatte(), 125, 375);
                w.addObject(new Zirkonplatte(), 675 - Greenfoot.getRandomNumber(2) * 70, 375); // zwei Zirkonplatten liegen an unterschiedlichen Stellen, dass Lernende gezwungen sind, auch noch zu prüfen, ob die Platte berührt wird
                // w.addObject(new Zirkonplatte(), 675, 125 + Greenfoot.getRandomNumber(2) * 50);
                w.addObject(new Zirkonplatte(), 225 + Greenfoot.getRandomNumber(2) * 70, 325);
                break;

            case e7m4:
                for(int i = 1; i <= 7; i++) {
                    Zirkonplatte z = new Zirkonplatte();
                    w.addObject(z,125, 375);
                }
                break;
            case e7m5:

                break;
            case e7m6:
                break;
            case e7m7:
 

                break;
        }
    }
}
